import { u as isArray, b as isSymbol, v as getNative, w as Map, i as toString, c as baseGetTag, d as isObjectLike, x as isLength } from "./chunk-d2b1926f.js";
import { b as eq, c as isIndex } from "./chunk-df46c743.js";
var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, reIsPlainProp = /^\w*$/;
function isKey(e, a) { if (isArray(e))
    return !1; var t = typeof e; return !("number" != t && "symbol" != t && "boolean" != t && null != e && !isSymbol(e)) || reIsPlainProp.test(e) || !reIsDeepProp.test(e) || null != a && e in Object(a); }
var _isKey = isKey, nativeCreate = getNative(Object, "create"), _nativeCreate = nativeCreate;
function hashClear() { this.__data__ = _nativeCreate ? _nativeCreate(null) : {}, this.size = 0; }
var _hashClear = hashClear;
function hashDelete(e) { var a = this.has(e) && delete this.__data__[e]; return this.size -= a ? 1 : 0, a; }
var _hashDelete = hashDelete, HASH_UNDEFINED = "__lodash_hash_undefined__", objectProto = Object.prototype, hasOwnProperty = objectProto.hasOwnProperty;
function hashGet(e) { var a = this.__data__; if (_nativeCreate) {
    var t = a[e];
    return t === HASH_UNDEFINED ? void 0 : t;
} return hasOwnProperty.call(a, e) ? a[e] : void 0; }
var _hashGet = hashGet, objectProto$1 = Object.prototype, hasOwnProperty$1 = objectProto$1.hasOwnProperty;
function hashHas(e) { var a = this.__data__; return _nativeCreate ? void 0 !== a[e] : hasOwnProperty$1.call(a, e); }
var _hashHas = hashHas, HASH_UNDEFINED$1 = "__lodash_hash_undefined__";
function hashSet(e, a) { var t = this.__data__; return this.size += this.has(e) ? 0 : 1, t[e] = _nativeCreate && void 0 === a ? HASH_UNDEFINED$1 : a, this; }
var _hashSet = hashSet;
function Hash(e) { var a = -1, t = null == e ? 0 : e.length; for (this.clear(); ++a < t;) {
    var r = e[a];
    this.set(r[0], r[1]);
} }
Hash.prototype.clear = _hashClear, Hash.prototype.delete = _hashDelete, Hash.prototype.get = _hashGet, Hash.prototype.has = _hashHas, Hash.prototype.set = _hashSet;
var _Hash = Hash;
function listCacheClear() { this.__data__ = [], this.size = 0; }
var _listCacheClear = listCacheClear;
function assocIndexOf(e, a) { for (var t = e.length; t--;)
    if (eq(e[t][0], a))
        return t; return -1; }
var _assocIndexOf = assocIndexOf, arrayProto = Array.prototype, splice = arrayProto.splice;
function listCacheDelete(e) { var a = this.__data__, t = _assocIndexOf(a, e); return !(t < 0 || (t == a.length - 1 ? a.pop() : splice.call(a, t, 1), --this.size, 0)); }
var _listCacheDelete = listCacheDelete;
function listCacheGet(e) { var a = this.__data__, t = _assocIndexOf(a, e); return t < 0 ? void 0 : a[t][1]; }
var _listCacheGet = listCacheGet;
function listCacheHas(e) { return _assocIndexOf(this.__data__, e) > -1; }
var _listCacheHas = listCacheHas;
function listCacheSet(e, a) { var t = this.__data__, r = _assocIndexOf(t, e); return r < 0 ? (++this.size, t.push([e, a])) : t[r][1] = a, this; }
var _listCacheSet = listCacheSet;
function ListCache(e) { var a = -1, t = null == e ? 0 : e.length; for (this.clear(); ++a < t;) {
    var r = e[a];
    this.set(r[0], r[1]);
} }
ListCache.prototype.clear = _listCacheClear, ListCache.prototype.delete = _listCacheDelete, ListCache.prototype.get = _listCacheGet, ListCache.prototype.has = _listCacheHas, ListCache.prototype.set = _listCacheSet;
var _ListCache = ListCache;
function mapCacheClear() { this.size = 0, this.__data__ = { hash: new _Hash, map: new (Map || _ListCache), string: new _Hash }; }
var _mapCacheClear = mapCacheClear;
function isKeyable(e) { var a = typeof e; return "string" == a || "number" == a || "symbol" == a || "boolean" == a ? "__proto__" !== e : null === e; }
var _isKeyable = isKeyable;
function getMapData(e, a) { var t = e.__data__; return _isKeyable(a) ? t["string" == typeof a ? "string" : "hash"] : t.map; }
var _getMapData = getMapData;
function mapCacheDelete(e) { var a = _getMapData(this, e).delete(e); return this.size -= a ? 1 : 0, a; }
var _mapCacheDelete = mapCacheDelete;
function mapCacheGet(e) { return _getMapData(this, e).get(e); }
var _mapCacheGet = mapCacheGet;
function mapCacheHas(e) { return _getMapData(this, e).has(e); }
var _mapCacheHas = mapCacheHas;
function mapCacheSet(e, a) { var t = _getMapData(this, e), r = t.size; return t.set(e, a), this.size += t.size == r ? 0 : 1, this; }
var _mapCacheSet = mapCacheSet;
function MapCache(e) { var a = -1, t = null == e ? 0 : e.length; for (this.clear(); ++a < t;) {
    var r = e[a];
    this.set(r[0], r[1]);
} }
MapCache.prototype.clear = _mapCacheClear, MapCache.prototype.delete = _mapCacheDelete, MapCache.prototype.get = _mapCacheGet, MapCache.prototype.has = _mapCacheHas, MapCache.prototype.set = _mapCacheSet;
var _MapCache = MapCache, FUNC_ERROR_TEXT = "Expected a function";
function memoize(e, a) { if ("function" != typeof e || null != a && "function" != typeof a)
    throw new TypeError(FUNC_ERROR_TEXT); var t = function () { var r = arguments, s = a ? a.apply(this, r) : r[0], h = t.cache; if (h.has(s))
    return h.get(s); var n = e.apply(this, r); return t.cache = h.set(s, n) || h, n; }; return t.cache = new (memoize.Cache || _MapCache), t; }
memoize.Cache = _MapCache;
var memoize_1 = memoize, MAX_MEMOIZE_SIZE = 500;
function memoizeCapped(e) { var a = memoize_1(e, function (e) { return t.size === MAX_MEMOIZE_SIZE && t.clear(), e; }), t = a.cache; return a; }
var _memoizeCapped = memoizeCapped, rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, reEscapeChar = /\\(\\)?/g, stringToPath = _memoizeCapped(function (e) { var a = []; return 46 === e.charCodeAt(0) && a.push(""), e.replace(rePropName, function (e, t, r, s) { a.push(r ? s.replace(reEscapeChar, "$1") : t || e); }), a; }), _stringToPath = stringToPath;
function castPath(e, a) { return isArray(e) ? e : _isKey(e, a) ? [e] : _stringToPath(toString(e)); }
var _castPath = castPath, INFINITY = 1 / 0;
function toKey(e) { if ("string" == typeof e || isSymbol(e))
    return e; var a = e + ""; return "0" == a && 1 / e == -INFINITY ? "-0" : a; }
var _toKey = toKey, objectProto$2 = Object.prototype, hasOwnProperty$2 = objectProto$2.hasOwnProperty;
function baseHas(e, a) { return null != e && hasOwnProperty$2.call(e, a); }
var _baseHas = baseHas, argsTag = "[object Arguments]";
function baseIsArguments(e) { return isObjectLike(e) && baseGetTag(e) == argsTag; }
var isArguments_1, _baseIsArguments = baseIsArguments, objectProto$3 = Object.prototype, hasOwnProperty$3 = objectProto$3.hasOwnProperty, propertyIsEnumerable = objectProto$3.propertyIsEnumerable, isArguments = _baseIsArguments(function () { return arguments; }()) ? _baseIsArguments : function (e) { return isObjectLike(e) && hasOwnProperty$3.call(e, "callee") && !propertyIsEnumerable.call(e, "callee"); };
function hasPath(e, a, t) { for (var r = -1, s = (a = _castPath(a, e)).length, h = !1; ++r < s;) {
    var n = _toKey(a[r]);
    if (!(h = null != e && t(e, n)))
        break;
    e = e[n];
} return h || ++r != s ? h : !!(s = null == e ? 0 : e.length) && isLength(s) && isIndex(n, s) && (isArray(e) || isArguments_1(e)); }
var _hasPath = hasPath;
function has(e, a) { return null != e && _hasPath(e, a, _baseHas); }
var has_1 = has;
export { _castPath as a, _toKey as b, has_1 as c, isArguments as d, _MapCache as e };
