import '../../stencil.core';
export declare class BsTooltip {
    tooltipEl: HTMLElement;
    showEventName: string;
    shownEventName: string;
    hideEventName: string;
    hiddenEventName: string;
    insertedEventName: string;
    noEnableOnLoad: boolean;
    tabindex: string;
    bsContent: string;
    bsTitle: string;
    config: any;
    defaults: {
        animation: boolean;
        template: string;
        popoverTemplate: string;
        trigger: string;
        popoverTrigger: string;
        title: string;
        delay: number;
        html: boolean;
        selector: boolean;
        placement: string;
        popoverPlacement: string;
        offset: number;
        container: boolean;
        fallbackPlacement: string;
        boundary: string;
        disposeTimeToWait: number;
        toggle: string;
        content: string;
    };
    isEnabled: boolean;
    activeTrigger: any;
    tooltipId: string;
    tip: HTMLElement;
    popperHandle: any;
    hoverState: string;
    timeout: any;
    disposeTimeout: any;
    componentWillLoad(): void;
    componentDidUnload(): void;
    static getAttachment(placement: any): any;
    enableTooltip(): void;
    disableTooltip(): void;
    makeTip(): any;
    getTipElement(): HTMLElement;
    toggle(event?: any): void;
    isWithActiveTrigger(): boolean;
    tipHasClass(className: any): any;
    enter(event?: any): void;
    leave(event?: any): void;
    okToShow(): boolean;
    show(): void;
    handlePopperOnCreate: (data: any) => void;
    handlePopperOnUpdate: (data: any) => void;
    handlePopperPlacementChange(popperData: any): void;
    showComplete(): void;
    hide(callback?: any): void;
    hideComplete(callback?: any): void;
    removeTooltipFromDom(): void;
    fixTransition(): void;
    cleanTipClass(): void;
    addAttachmentClass(attachment: any): void;
    setContent(): void;
    setElementContent(el: any, content: any): void;
    getContent(): any;
    getTitle(): any;
    handleWatchBsTitle(newValue: any): void;
    handleWatchBsContent(newValue: any): void;
    handleClickTrigger: (event: any) => void;
    handleMouseEnter: (event: any) => void;
    handleFocusIn: (event: any) => void;
    handleMouseLeave: (event: any) => void;
    handleFocusOut: (event: any) => void;
    handleModalHide: (event: any) => void;
    bsRemoveEventListener(eventName: any, listenerFunction: any, callback?: () => void): void;
    bsAddEventListener(eventName: any, listenerFunction: any): void;
    setListeners(): void;
    fixTitle(): void;
    setConfig(overrideConfig?: any): void;
    setupMethod(tooltipOptions: any): boolean | HTMLElement;
    popover(popoverOptions?: any): boolean | HTMLElement;
    tooltip(tooltipOptions?: any): boolean | HTMLElement;
    render(): JSX.Element;
}
