import { i as toString, z as toString$1 } from "./chunk-d2b1926f.js";
for (var global$1 = "undefined" != typeof global ? global : "undefined" != typeof self ? self : "undefined" != typeof window ? window : {}, isBrowser = "undefined" != typeof window && "undefined" != typeof document, longerTimeoutBrowsers = ["Edge", "Trident", "Firefox"], timeoutDuration = 0, i = 0; i < longerTimeoutBrowsers.length; i += 1)
    if (isBrowser && navigator.userAgent.indexOf(longerTimeoutBrowsers[i]) >= 0) {
        timeoutDuration = 1;
        break;
    }
function microtaskDebounce(e) { var t = !1; return function () { t || (t = !0, window.Promise.resolve().then(function () { t = !1, e(); })); }; }
function taskDebounce(e) { var t = !1; return function () { t || (t = !0, setTimeout(function () { t = !1, e(); }, timeoutDuration)); }; }
var supportsMicroTasks = isBrowser && window.Promise, debounce = supportsMicroTasks ? microtaskDebounce : taskDebounce;
function isFunction(e) { return e && "[object Function]" === {}.toString.call(e); }
function getStyleComputedProperty(e, t) { if (1 !== e.nodeType)
    return []; var n = getComputedStyle(e, null); return t ? n[t] : n; }
function getParentNode(e) { return "HTML" === e.nodeName ? e : e.parentNode || e.host; }
function getScrollParent(e) { if (!e)
    return document.body; switch (e.nodeName) {
    case "HTML":
    case "BODY": return e.ownerDocument.body;
    case "#document": return e.body;
} var t = getStyleComputedProperty(e), n = t.overflow, o = t.overflowX, r = t.overflowY; return /(auto|scroll|overlay)/.test(n + r + o) ? e : getScrollParent(getParentNode(e)); }
var isIE11 = isBrowser && !(!window.MSInputMethodContext || !document.documentMode), isIE10 = isBrowser && /MSIE 10/.test(navigator.userAgent);
function isIE(e) { return 11 === e ? isIE11 : 10 === e ? isIE10 : isIE11 || isIE10; }
function getOffsetParent(e) { if (!e)
    return document.documentElement; for (var t = isIE(10) ? document.body : null, n = e.offsetParent; n === t && e.nextElementSibling;)
    n = (e = e.nextElementSibling).offsetParent; var o = n && n.nodeName; return o && "BODY" !== o && "HTML" !== o ? -1 !== ["TD", "TABLE"].indexOf(n.nodeName) && "static" === getStyleComputedProperty(n, "position") ? getOffsetParent(n) : n : e ? e.ownerDocument.documentElement : document.documentElement; }
function isOffsetContainer(e) { var t = e.nodeName; return "BODY" !== t && ("HTML" === t || getOffsetParent(e.firstElementChild) === e); }
function getRoot(e) { return null !== e.parentNode ? getRoot(e.parentNode) : e; }
function findCommonOffsetParent(e, t) { if (!(e && e.nodeType && t && t.nodeType))
    return document.documentElement; var n = e.compareDocumentPosition(t) & Node.DOCUMENT_POSITION_FOLLOWING, o = n ? e : t, r = n ? t : e, i = document.createRange(); i.setStart(o, 0), i.setEnd(r, 0); var s = i.commonAncestorContainer; if (e !== s && t !== s || o.contains(r))
    return isOffsetContainer(s) ? s : getOffsetParent(s); var a = getRoot(e); return a.host ? findCommonOffsetParent(a.host, t) : findCommonOffsetParent(e, getRoot(t).host); }
function getScroll(e) { var t = "top" === (arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : "top") ? "scrollTop" : "scrollLeft", n = e.nodeName; if ("BODY" === n || "HTML" === n) {
    var o = e.ownerDocument.documentElement;
    return (e.ownerDocument.scrollingElement || o)[t];
} return e[t]; }
function includeScroll(e, t) { var n = arguments.length > 2 && void 0 !== arguments[2] && arguments[2], o = getScroll(t, "top"), r = getScroll(t, "left"), i = n ? -1 : 1; return e.top += o * i, e.bottom += o * i, e.left += r * i, e.right += r * i, e; }
function getBordersSize(e, t) { var n = "x" === t ? "Left" : "Top", o = "Left" === n ? "Right" : "Bottom"; return parseFloat(e["border" + n + "Width"], 10) + parseFloat(e["border" + o + "Width"], 10); }
function getSize(e, t, n, o) { return Math.max(t["offset" + e], t["scroll" + e], n["client" + e], n["offset" + e], n["scroll" + e], isIE(10) ? parseInt(n["offset" + e]) + parseInt(o["margin" + ("Height" === e ? "Top" : "Left")]) + parseInt(o["margin" + ("Height" === e ? "Bottom" : "Right")]) : 0); }
function getWindowSizes(e) { var t = e.body, n = e.documentElement, o = isIE(10) && getComputedStyle(n); return { height: getSize("Height", t, n, o), width: getSize("Width", t, n, o) }; }
var classCallCheck = function (e, t) { if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function"); }, createClass = function () { function e(e, t) { for (var n = 0; n < t.length; n++) {
    var o = t[n];
    o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, o.key, o);
} } return function (t, n, o) { return n && e(t.prototype, n), o && e(t, o), t; }; }(), defineProperty = function (e, t, n) { return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e; }, _extends = Object.assign || function (e) { for (var t = 1; t < arguments.length; t++) {
    var n = arguments[t];
    for (var o in n)
        Object.prototype.hasOwnProperty.call(n, o) && (e[o] = n[o]);
} return e; };
function getClientRect(e) { return _extends({}, e, { right: e.left + e.width, bottom: e.top + e.height }); }
function getBoundingClientRect(e) { var t = {}; try {
    if (isIE(10)) {
        t = e.getBoundingClientRect();
        var n = getScroll(e, "top"), o = getScroll(e, "left");
        t.top += n, t.left += o, t.bottom += n, t.right += o;
    }
    else
        t = e.getBoundingClientRect();
}
catch (e) { } var r = { left: t.left, top: t.top, width: t.right - t.left, height: t.bottom - t.top }, i = "HTML" === e.nodeName ? getWindowSizes(e.ownerDocument) : {}, s = i.width || e.clientWidth || r.right - r.left, a = i.height || e.clientHeight || r.bottom - r.top, f = e.offsetWidth - s, p = e.offsetHeight - a; if (f || p) {
    var l = getStyleComputedProperty(e);
    f -= getBordersSize(l, "x"), p -= getBordersSize(l, "y"), r.width -= f, r.height -= p;
} return getClientRect(r); }
function getOffsetRectRelativeToArbitraryNode(e, t) { var n = arguments.length > 2 && void 0 !== arguments[2] && arguments[2], o = isIE(10), r = "HTML" === t.nodeName, i = getBoundingClientRect(e), s = getBoundingClientRect(t), a = getScrollParent(e), f = getStyleComputedProperty(t), p = parseFloat(f.borderTopWidth, 10), l = parseFloat(f.borderLeftWidth, 10); n && r && (s.top = Math.max(s.top, 0), s.left = Math.max(s.left, 0)); var d = getClientRect({ top: i.top - s.top - p, left: i.left - s.left - l, width: i.width, height: i.height }); if (d.marginTop = 0, d.marginLeft = 0, !o && r) {
    var u = parseFloat(f.marginTop, 10), c = parseFloat(f.marginLeft, 10);
    d.top -= p - u, d.bottom -= p - u, d.left -= l - c, d.right -= l - c, d.marginTop = u, d.marginLeft = c;
} return (o && !n ? t.contains(a) : t === a && "BODY" !== a.nodeName) && (d = includeScroll(d, t)), d; }
function getViewportOffsetRectRelativeToArtbitraryNode(e) { var t = arguments.length > 1 && void 0 !== arguments[1] && arguments[1], n = e.ownerDocument.documentElement, o = getOffsetRectRelativeToArbitraryNode(e, n), r = Math.max(n.clientWidth, window.innerWidth || 0), i = Math.max(n.clientHeight, window.innerHeight || 0), s = t ? 0 : getScroll(n), a = t ? 0 : getScroll(n, "left"); return getClientRect({ top: s - o.top + o.marginTop, left: a - o.left + o.marginLeft, width: r, height: i }); }
function isFixed(e) { var t = e.nodeName; return "BODY" !== t && "HTML" !== t && ("fixed" === getStyleComputedProperty(e, "position") || isFixed(getParentNode(e))); }
function getFixedPositionOffsetParent(e) { if (!e || !e.parentElement || isIE())
    return document.documentElement; for (var t = e.parentElement; t && "none" === getStyleComputedProperty(t, "transform");)
    t = t.parentElement; return t || document.documentElement; }
function getBoundaries(e, t, n, o) { var r = arguments.length > 4 && void 0 !== arguments[4] && arguments[4], i = { top: 0, left: 0 }, s = r ? getFixedPositionOffsetParent(e) : findCommonOffsetParent(e, t); if ("viewport" === o)
    i = getViewportOffsetRectRelativeToArtbitraryNode(s, r);
else {
    var a = void 0;
    "scrollParent" === o ? "BODY" === (a = getScrollParent(getParentNode(t))).nodeName && (a = e.ownerDocument.documentElement) : a = "window" === o ? e.ownerDocument.documentElement : o;
    var f = getOffsetRectRelativeToArbitraryNode(a, s, r);
    if ("HTML" !== a.nodeName || isFixed(s))
        i = f;
    else {
        var p = getWindowSizes(e.ownerDocument), l = p.height, d = p.width;
        i.top += f.top - f.marginTop, i.bottom = l + f.top, i.left += f.left - f.marginLeft, i.right = d + f.left;
    }
} var u = "number" == typeof (n = n || 0); return i.left += u ? n : n.left || 0, i.top += u ? n : n.top || 0, i.right -= u ? n : n.right || 0, i.bottom -= u ? n : n.bottom || 0, i; }
function getArea(e) { return e.width * e.height; }
function computeAutoPlacement(e, t, n, o, r) { var i = arguments.length > 5 && void 0 !== arguments[5] ? arguments[5] : 0; if (-1 === e.indexOf("auto"))
    return e; var s = getBoundaries(n, o, i, r), a = { top: { width: s.width, height: t.top - s.top }, right: { width: s.right - t.right, height: s.height }, bottom: { width: s.width, height: s.bottom - t.bottom }, left: { width: t.left - s.left, height: s.height } }, f = Object.keys(a).map(function (e) { return _extends({ key: e }, a[e], { area: getArea(a[e]) }); }).sort(function (e, t) { return t.area - e.area; }), p = f.filter(function (e) { var t = e.width, o = e.height; return t >= n.clientWidth && o >= n.clientHeight; }), l = p.length > 0 ? p[0].key : f[0].key, d = e.split("-")[1]; return l + (d ? "-" + d : ""); }
function getReferenceOffsets(e, t, n) { var o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null; return getOffsetRectRelativeToArbitraryNode(n, o ? getFixedPositionOffsetParent(t) : findCommonOffsetParent(t, n), o); }
function getOuterSizes(e) { var t = getComputedStyle(e), n = parseFloat(t.marginTop) + parseFloat(t.marginBottom), o = parseFloat(t.marginLeft) + parseFloat(t.marginRight); return { width: e.offsetWidth + o, height: e.offsetHeight + n }; }
function getOppositePlacement(e) { var t = { left: "right", right: "left", bottom: "top", top: "bottom" }; return e.replace(/left|right|bottom|top/g, function (e) { return t[e]; }); }
function getPopperOffsets(e, t, n) { n = n.split("-")[0]; var o = getOuterSizes(e), r = { width: o.width, height: o.height }, i = -1 !== ["right", "left"].indexOf(n), s = i ? "top" : "left", a = i ? "left" : "top", f = i ? "height" : "width", p = i ? "width" : "height"; return r[s] = t[s] + t[f] / 2 - o[f] / 2, r[a] = n === a ? t[a] - o[p] : t[getOppositePlacement(a)], r; }
function find(e, t) { return Array.prototype.find ? e.find(t) : e.filter(t)[0]; }
function findIndex(e, t, n) { if (Array.prototype.findIndex)
    return e.findIndex(function (e) { return e[t] === n; }); var o = find(e, function (e) { return e[t] === n; }); return e.indexOf(o); }
function runModifiers(e, t, n) { return (void 0 === n ? e : e.slice(0, findIndex(e, "name", n))).forEach(function (e) { e.function && console.warn("`modifier.function` is deprecated, use `modifier.fn`!"); var n = e.function || e.fn; e.enabled && isFunction(n) && (t.offsets.popper = getClientRect(t.offsets.popper), t.offsets.reference = getClientRect(t.offsets.reference), t = n(t, e)); }), t; }
function update() { if (!this.state.isDestroyed) {
    var e = { instance: this, styles: {}, arrowStyles: {}, attributes: {}, flipped: !1, offsets: {} };
    e.offsets.reference = getReferenceOffsets(this.state, this.popper, this.reference, this.options.positionFixed), e.placement = computeAutoPlacement(this.options.placement, e.offsets.reference, this.popper, this.reference, this.options.modifiers.flip.boundariesElement, this.options.modifiers.flip.padding), e.originalPlacement = e.placement, e.positionFixed = this.options.positionFixed, e.offsets.popper = getPopperOffsets(this.popper, e.offsets.reference, e.placement), e.offsets.popper.position = this.options.positionFixed ? "fixed" : "absolute", e = runModifiers(this.modifiers, e), this.state.isCreated ? this.options.onUpdate(e) : (this.state.isCreated = !0, this.options.onCreate(e));
} }
function isModifierEnabled(e, t) { return e.some(function (e) { var n = e.name; return e.enabled && n === t; }); }
function getSupportedPropertyName(e) { for (var t = [!1, "ms", "Webkit", "Moz", "O"], n = e.charAt(0).toUpperCase() + e.slice(1), o = 0; o < t.length; o++) {
    var r = t[o], i = r ? "" + r + n : e;
    if (void 0 !== document.body.style[i])
        return i;
} return null; }
function destroy() { return this.state.isDestroyed = !0, isModifierEnabled(this.modifiers, "applyStyle") && (this.popper.removeAttribute("x-placement"), this.popper.style.position = "", this.popper.style.top = "", this.popper.style.left = "", this.popper.style.right = "", this.popper.style.bottom = "", this.popper.style.willChange = "", this.popper.style[getSupportedPropertyName("transform")] = ""), this.disableEventListeners(), this.options.removeOnDestroy && this.popper.parentNode.removeChild(this.popper), this; }
function getWindow(e) { var t = e.ownerDocument; return t ? t.defaultView : window; }
function attachToScrollParents(e, t, n, o) { var r = "BODY" === e.nodeName, i = r ? e.ownerDocument.defaultView : e; i.addEventListener(t, n, { passive: !0 }), r || attachToScrollParents(getScrollParent(i.parentNode), t, n, o), o.push(i); }
function setupEventListeners(e, t, n, o) { n.updateBound = o, getWindow(e).addEventListener("resize", n.updateBound, { passive: !0 }); var r = getScrollParent(e); return attachToScrollParents(r, "scroll", n.updateBound, n.scrollParents), n.scrollElement = r, n.eventsEnabled = !0, n; }
function enableEventListeners() { this.state.eventsEnabled || (this.state = setupEventListeners(this.reference, this.options, this.state, this.scheduleUpdate)); }
function removeEventListeners(e, t) { return getWindow(e).removeEventListener("resize", t.updateBound), t.scrollParents.forEach(function (e) { e.removeEventListener("scroll", t.updateBound); }), t.updateBound = null, t.scrollParents = [], t.scrollElement = null, t.eventsEnabled = !1, t; }
function disableEventListeners() { this.state.eventsEnabled && (cancelAnimationFrame(this.scheduleUpdate), this.state = removeEventListeners(this.reference, this.state)); }
function isNumeric(e) { return "" !== e && !isNaN(parseFloat(e)) && isFinite(e); }
function setStyles(e, t) { Object.keys(t).forEach(function (n) { var o = ""; -1 !== ["width", "height", "top", "right", "bottom", "left"].indexOf(n) && isNumeric(t[n]) && (o = "px"), e.style[n] = t[n] + o; }); }
function setAttributes(e, t) { Object.keys(t).forEach(function (n) { !1 !== t[n] ? e.setAttribute(n, t[n]) : e.removeAttribute(n); }); }
function applyStyle(e) { return setStyles(e.instance.popper, e.styles), setAttributes(e.instance.popper, e.attributes), e.arrowElement && Object.keys(e.arrowStyles).length && setStyles(e.arrowElement, e.arrowStyles), e; }
function applyStyleOnLoad(e, t, n, o, r) { var i = getReferenceOffsets(r, t, e, n.positionFixed), s = computeAutoPlacement(n.placement, i, t, e, n.modifiers.flip.boundariesElement, n.modifiers.flip.padding); return t.setAttribute("x-placement", s), setStyles(t, { position: n.positionFixed ? "fixed" : "absolute" }), n; }
function computeStyle(e, t) { var n = t.x, o = t.y, r = e.offsets.popper, i = find(e.instance.modifiers, function (e) { return "applyStyle" === e.name; }).gpuAcceleration; void 0 !== i && console.warn("WARNING: `gpuAcceleration` option moved to `computeStyle` modifier and will not be supported in future versions of Popper.js!"); var s, a, f = void 0 !== i ? i : t.gpuAcceleration, p = getOffsetParent(e.instance.popper), l = getBoundingClientRect(p), d = { position: r.position }, u = { left: Math.floor(r.left), top: Math.round(r.top), bottom: Math.round(r.bottom), right: Math.floor(r.right) }, c = "bottom" === n ? "top" : "bottom", m = "right" === o ? "left" : "right", h = getSupportedPropertyName("transform"); if (a = "bottom" === c ? "HTML" === p.nodeName ? -p.clientHeight + u.bottom : -l.height + u.bottom : u.top, s = "right" === m ? "HTML" === p.nodeName ? -p.clientWidth + u.right : -l.width + u.right : u.left, f && h)
    d[h] = "translate3d(" + s + "px, " + a + "px, 0)", d[c] = 0, d[m] = 0, d.willChange = "transform";
else {
    var g = "bottom" === c ? -1 : 1, v = "right" === m ? -1 : 1;
    d[c] = a * g, d[m] = s * v, d.willChange = c + ", " + m;
} var b = { "x-placement": e.placement }; return e.attributes = _extends({}, b, e.attributes), e.styles = _extends({}, d, e.styles), e.arrowStyles = _extends({}, e.offsets.arrow, e.arrowStyles), e; }
function isModifierRequired(e, t, n) { var o = find(e, function (e) { return e.name === t; }), r = !!o && e.some(function (e) { return e.name === n && e.enabled && e.order < o.order; }); if (!r) {
    var i = "`" + t + "`", s = "`" + n + "`";
    console.warn(s + " modifier is required by " + i + " modifier in order to work, be sure to include it before " + i + "!");
} return r; }
function arrow(e, t) { var n; if (!isModifierRequired(e.instance.modifiers, "arrow", "keepTogether"))
    return e; var o = t.element; if ("string" == typeof o) {
    if (!(o = e.instance.popper.querySelector(o)))
        return e;
}
else if (!e.instance.popper.contains(o))
    return console.warn("WARNING: `arrow.element` must be child of its popper element!"), e; var r = e.placement.split("-")[0], i = e.offsets, s = i.popper, a = i.reference, f = -1 !== ["left", "right"].indexOf(r), p = f ? "height" : "width", l = f ? "Top" : "Left", d = l.toLowerCase(), u = f ? "left" : "top", c = f ? "bottom" : "right", m = getOuterSizes(o)[p]; a[c] - m < s[d] && (e.offsets.popper[d] -= s[d] - (a[c] - m)), a[d] + m > s[c] && (e.offsets.popper[d] += a[d] + m - s[c]), e.offsets.popper = getClientRect(e.offsets.popper); var h = a[d] + a[p] / 2 - m / 2, g = getStyleComputedProperty(e.instance.popper), v = parseFloat(g["margin" + l], 10), b = parseFloat(g["border" + l + "Width"], 10), y = h - e.offsets.popper[d] - v - b; return y = Math.max(Math.min(s[p] - m, y), 0), e.arrowElement = o, e.offsets.arrow = (defineProperty(n = {}, d, Math.round(y)), defineProperty(n, u, ""), n), e; }
function getOppositeVariation(e) { return "end" === e ? "start" : "start" === e ? "end" : e; }
var placements = ["auto-start", "auto", "auto-end", "top-start", "top", "top-end", "right-start", "right", "right-end", "bottom-end", "bottom", "bottom-start", "left-end", "left", "left-start"], validPlacements = placements.slice(3);
function clockwise(e) { var t = arguments.length > 1 && void 0 !== arguments[1] && arguments[1], n = validPlacements.indexOf(e), o = validPlacements.slice(n + 1).concat(validPlacements.slice(0, n)); return t ? o.reverse() : o; }
var BEHAVIORS = { FLIP: "flip", CLOCKWISE: "clockwise", COUNTERCLOCKWISE: "counterclockwise" };
function flip(e, t) { if (isModifierEnabled(e.instance.modifiers, "inner"))
    return e; if (e.flipped && e.placement === e.originalPlacement)
    return e; var n = getBoundaries(e.instance.popper, e.instance.reference, t.padding, t.boundariesElement, e.positionFixed), o = e.placement.split("-")[0], r = getOppositePlacement(o), i = e.placement.split("-")[1] || "", s = []; switch (t.behavior) {
    case BEHAVIORS.FLIP:
        s = [o, r];
        break;
    case BEHAVIORS.CLOCKWISE:
        s = clockwise(o);
        break;
    case BEHAVIORS.COUNTERCLOCKWISE:
        s = clockwise(o, !0);
        break;
    default: s = t.behavior;
} return s.forEach(function (a, f) { if (o !== a || s.length === f + 1)
    return e; o = e.placement.split("-")[0], r = getOppositePlacement(o); var p = e.offsets.popper, l = e.offsets.reference, d = Math.floor, u = "left" === o && d(p.right) > d(l.left) || "right" === o && d(p.left) < d(l.right) || "top" === o && d(p.bottom) > d(l.top) || "bottom" === o && d(p.top) < d(l.bottom), c = d(p.left) < d(n.left), m = d(p.right) > d(n.right), h = d(p.top) < d(n.top), g = d(p.bottom) > d(n.bottom), v = "left" === o && c || "right" === o && m || "top" === o && h || "bottom" === o && g, b = -1 !== ["top", "bottom"].indexOf(o), y = !!t.flipVariations && (b && "start" === i && c || b && "end" === i && m || !b && "start" === i && h || !b && "end" === i && g); (u || v || y) && (e.flipped = !0, (u || v) && (o = s[f + 1]), y && (i = getOppositeVariation(i)), e.placement = o + (i ? "-" + i : ""), e.offsets.popper = _extends({}, e.offsets.popper, getPopperOffsets(e.instance.popper, e.offsets.reference, e.placement)), e = runModifiers(e.instance.modifiers, e, "flip")); }), e; }
function keepTogether(e) { var t = e.offsets, n = t.popper, o = t.reference, r = e.placement.split("-")[0], i = Math.floor, s = -1 !== ["top", "bottom"].indexOf(r), a = s ? "right" : "bottom", f = s ? "left" : "top", p = s ? "width" : "height"; return n[a] < i(o[f]) && (e.offsets.popper[f] = i(o[f]) - n[p]), n[f] > i(o[a]) && (e.offsets.popper[f] = i(o[a])), e; }
function toValue(e, t, n, o) { var r = e.match(/((?:\-|\+)?\d*\.?\d*)(.*)/), i = +r[1], s = r[2]; if (!i)
    return e; if (0 === s.indexOf("%")) {
    var a = void 0;
    switch (s) {
        case "%p":
            a = n;
            break;
        case "%":
        case "%r":
        default: a = o;
    }
    return getClientRect(a)[t] / 100 * i;
} return "vh" === s || "vw" === s ? ("vh" === s ? Math.max(document.documentElement.clientHeight, window.innerHeight || 0) : Math.max(document.documentElement.clientWidth, window.innerWidth || 0)) / 100 * i : i; }
function parseOffset(e, t, n, o) { var r = [0, 0], i = -1 !== ["right", "left"].indexOf(o), s = e.split(/(\+|\-)/).map(function (e) { return e.trim(); }), a = s.indexOf(find(s, function (e) { return -1 !== e.search(/,|\s/); })); s[a] && -1 === s[a].indexOf(",") && console.warn("Offsets separated by white space(s) are deprecated, use a comma (,) instead."); var f = /\s*,\s*|\s+/, p = -1 !== a ? [s.slice(0, a).concat([s[a].split(f)[0]]), [s[a].split(f)[1]].concat(s.slice(a + 1))] : [s]; return (p = p.map(function (e, o) { var r = (1 === o ? !i : i) ? "height" : "width", s = !1; return e.reduce(function (e, t) { return "" === e[e.length - 1] && -1 !== ["+", "-"].indexOf(t) ? (e[e.length - 1] = t, s = !0, e) : s ? (e[e.length - 1] += t, s = !1, e) : e.concat(t); }, []).map(function (e) { return toValue(e, r, t, n); }); })).forEach(function (e, t) { e.forEach(function (n, o) { isNumeric(n) && (r[t] += n * ("-" === e[o - 1] ? -1 : 1)); }); }), r; }
function offset(e, t) { var n, o = t.offset, r = e.placement, i = e.offsets, s = i.popper, a = i.reference, f = r.split("-")[0]; return n = isNumeric(+o) ? [+o, 0] : parseOffset(o, s, a, f), "left" === f ? (s.top += n[0], s.left -= n[1]) : "right" === f ? (s.top += n[0], s.left += n[1]) : "top" === f ? (s.left += n[0], s.top -= n[1]) : "bottom" === f && (s.left += n[0], s.top += n[1]), e.popper = s, e; }
function preventOverflow(e, t) { var n = t.boundariesElement || getOffsetParent(e.instance.popper); e.instance.reference === n && (n = getOffsetParent(n)); var o = getSupportedPropertyName("transform"), r = e.instance.popper.style, i = r.top, s = r.left, a = r[o]; r.top = "", r.left = "", r[o] = ""; var f = getBoundaries(e.instance.popper, e.instance.reference, t.padding, n, e.positionFixed); r.top = i, r.left = s, r[o] = a, t.boundaries = f; var p = t.priority, l = e.offsets.popper, d = { primary: function (e) { var n = l[e]; return l[e] < f[e] && !t.escapeWithReference && (n = Math.max(l[e], f[e])), defineProperty({}, e, n); }, secondary: function (e) { var n = "right" === e ? "left" : "top", o = l[n]; return l[e] > f[e] && !t.escapeWithReference && (o = Math.min(l[n], f[e] - ("right" === e ? l.width : l.height))), defineProperty({}, n, o); } }; return p.forEach(function (e) { var t = -1 !== ["left", "top"].indexOf(e) ? "primary" : "secondary"; l = _extends({}, l, d[t](e)); }), e.offsets.popper = l, e; }
function shift(e) { var t = e.placement, n = t.split("-")[0], o = t.split("-")[1]; if (o) {
    var r = e.offsets, i = r.reference, s = r.popper, a = -1 !== ["bottom", "top"].indexOf(n), f = a ? "left" : "top", p = a ? "width" : "height", l = { start: defineProperty({}, f, i[f]), end: defineProperty({}, f, i[f] + i[p] - s[p]) };
    e.offsets.popper = _extends({}, s, l[o]);
} return e; }
function hide(e) { if (!isModifierRequired(e.instance.modifiers, "hide", "preventOverflow"))
    return e; var t = e.offsets.reference, n = find(e.instance.modifiers, function (e) { return "preventOverflow" === e.name; }).boundaries; if (t.bottom < n.top || t.left > n.right || t.top > n.bottom || t.right < n.left) {
    if (!0 === e.hide)
        return e;
    e.hide = !0, e.attributes["x-out-of-boundaries"] = "";
}
else {
    if (!1 === e.hide)
        return e;
    e.hide = !1, e.attributes["x-out-of-boundaries"] = !1;
} return e; }
function inner(e) { var t = e.placement, n = t.split("-")[0], o = e.offsets, r = o.popper, i = o.reference, s = -1 !== ["left", "right"].indexOf(n), a = -1 === ["top", "left"].indexOf(n); return r[s ? "left" : "top"] = i[n] - (a ? r[s ? "width" : "height"] : 0), e.placement = getOppositePlacement(t), e.offsets.popper = getClientRect(r), e; }
var modifiers = { shift: { order: 100, enabled: !0, fn: shift }, offset: { order: 200, enabled: !0, fn: offset, offset: 0 }, preventOverflow: { order: 300, enabled: !0, fn: preventOverflow, priority: ["left", "right", "top", "bottom"], padding: 5, boundariesElement: "scrollParent" }, keepTogether: { order: 400, enabled: !0, fn: keepTogether }, arrow: { order: 500, enabled: !0, fn: arrow, element: "[x-arrow]" }, flip: { order: 600, enabled: !0, fn: flip, behavior: "flip", padding: 5, boundariesElement: "viewport" }, inner: { order: 700, enabled: !1, fn: inner }, hide: { order: 800, enabled: !0, fn: hide }, computeStyle: { order: 850, enabled: !0, fn: computeStyle, gpuAcceleration: !0, x: "bottom", y: "right" }, applyStyle: { order: 900, enabled: !0, fn: applyStyle, onLoad: applyStyleOnLoad, gpuAcceleration: void 0 } }, Defaults = { placement: "bottom", positionFixed: !1, eventsEnabled: !0, removeOnDestroy: !1, onCreate: function () { }, onUpdate: function () { }, modifiers: modifiers }, Popper = function () { function e(t, n) { var o = this, r = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : {}; classCallCheck(this, e), this.scheduleUpdate = function () { return requestAnimationFrame(o.update); }, this.update = debounce(this.update.bind(this)), this.options = _extends({}, e.Defaults, r), this.state = { isDestroyed: !1, isCreated: !1, scrollParents: [] }, this.reference = t && t.jquery ? t[0] : t, this.popper = n && n.jquery ? n[0] : n, this.options.modifiers = {}, Object.keys(_extends({}, e.Defaults.modifiers, r.modifiers)).forEach(function (t) { o.options.modifiers[t] = _extends({}, e.Defaults.modifiers[t] || {}, r.modifiers ? r.modifiers[t] : {}); }), this.modifiers = Object.keys(this.options.modifiers).map(function (e) { return _extends({ name: e }, o.options.modifiers[e]); }).sort(function (e, t) { return e.order - t.order; }), this.modifiers.forEach(function (e) { e.enabled && isFunction(e.onLoad) && e.onLoad(o.reference, o.popper, o.options, e, o.state); }), this.update(); var i = this.options.eventsEnabled; i && this.enableEventListeners(), this.state.eventsEnabled = i; } return createClass(e, [{ key: "update", value: function () { return update.call(this); } }, { key: "destroy", value: function () { return destroy.call(this); } }, { key: "enableEventListeners", value: function () { return enableEventListeners.call(this); } }, { key: "disableEventListeners", value: function () { return disableEventListeners.call(this); } }]), e; }();
Popper.Utils = ("undefined" != typeof window ? window : global$1).PopperUtils, Popper.placements = placements, Popper.Defaults = Defaults;
var idCounter = 0;
function uniqueId(e) { var t = ++idCounter; return toString(e) + t; }
var uniqueId_1 = uniqueId;
function getUniqueId(e) { var t = btoa(toString$1(Math.random())).substring(5, 10); return uniqueId_1(e + "-" + t + "-"); }
export { Popper as a, getUniqueId as b };
