import { a as isObject, b as isSymbol, c as baseGetTag, d as isObjectLike, e as baseToString, f as castSlice, g as charsEndIndex, h as stringToArray, i as toString, j as isArrayLike, l as createCommonjsModule, m as freeGlobal, n as hasUnicode, o as toLower } from "./chunk-d2b1926f.js";
var NAN = NaN, reTrim = /^\s+|\s+$/g, reIsBadHex = /^[-+]0x[0-9a-f]+$/i, reIsBinary = /^0b[01]+$/i, reIsOctal = /^0o[0-7]+$/i, freeParseInt = parseInt;
function toNumber(e) { if ("number" == typeof e)
    return e; if (isSymbol(e))
    return NAN; if (isObject(e)) {
    var r = "function" == typeof e.valueOf ? e.valueOf() : e;
    e = isObject(r) ? r + "" : r;
} if ("string" != typeof e)
    return 0 === e ? e : +e; e = e.replace(reTrim, ""); var t = reIsBinary.test(e); return t || reIsOctal.test(e) ? freeParseInt(e.slice(2), t ? 2 : 8) : reIsBadHex.test(e) ? NAN : +e; }
var toNumber_1 = toNumber;
function baseExtremum(e, r, t) { for (var n = -1, i = e.length; ++n < i;) {
    var a = e[n], s = r(a);
    if (null != s && (void 0 === o ? s == s && !isSymbol(s) : t(s, o)))
        var o = s, u = a;
} return u; }
var _baseExtremum = baseExtremum;
function baseGt(e, r) { return e > r; }
var _baseGt = baseGt;
function identity(e) { return e; }
var identity_1 = identity;
function max(e) { return e && e.length ? _baseExtremum(e, identity_1, _baseGt) : void 0; }
var max_1 = max, numberTag = "[object Number]";
function isNumber(e) { return "number" == typeof e || isObjectLike(e) && baseGetTag(e) == numberTag; }
var isNumber_1 = isNumber;
function isNaN$1(e) { return isNumber_1(e) && e != +e; }
var _isNaN = isNaN$1, reTrimEnd = /\s+$/;
function trimEnd(e, r, t) { if ((e = toString(e)) && (t || void 0 === r))
    return e.replace(reTrimEnd, ""); if (!e || !(r = baseToString(r)))
    return e; var n = stringToArray(e), i = charsEndIndex(n, stringToArray(r)) + 1; return castSlice(n, 0, i).join(""); }
var trimEnd_1 = trimEnd;
function eq(e, r) { return e === r || e != e && r != r; }
var eq_1 = eq, MAX_SAFE_INTEGER = 9007199254740991, reIsUint = /^(?:0|[1-9]\d*)$/;
function isIndex(e, r) { var t = typeof e; return !!(r = null == r ? MAX_SAFE_INTEGER : r) && ("number" == t || "symbol" != t && reIsUint.test(e)) && e > -1 && e % 1 == 0 && e < r; }
var _isIndex = isIndex;
function isIterateeCall(e, r, t) { if (!isObject(t))
    return !1; var n = typeof r; return !!("number" == n ? isArrayLike(t) && _isIndex(r, t.length) : "string" == n && r in t) && eq_1(t[r], e); }
var _isIterateeCall = isIterateeCall, regexpTag = "[object RegExp]";
function baseIsRegExp(e) { return isObjectLike(e) && baseGetTag(e) == regexpTag; }
var _baseIsRegExp = baseIsRegExp;
function baseUnary(e) { return function (r) { return e(r); }; }
var split_1, _baseUnary = baseUnary, _nodeUtil = createCommonjsModule(function (e, r) { var t = r && !r.nodeType && r, n = t && e && !e.nodeType && e, i = n && n.exports === t && freeGlobal.process, a = function () { try {
    return n && n.require && n.require("util").types || i && i.binding && i.binding("util");
}
catch (e) { } }(); e.exports = a; }), nodeIsRegExp = _nodeUtil && _nodeUtil.isRegExp, isRegExp = nodeIsRegExp ? _baseUnary(nodeIsRegExp) : _baseIsRegExp, isRegExp_1 = isRegExp, MAX_ARRAY_LENGTH = 4294967295;
function split(e, r, t) { return t && "number" != typeof t && _isIterateeCall(e, r, t) && (r = t = void 0), (t = void 0 === t ? MAX_ARRAY_LENGTH : t >>> 0) ? (e = toString(e)) && ("string" == typeof r || null != r && !isRegExp_1(r)) && !(r = baseToString(r)) && hasUnicode(e) ? castSlice(stringToArray(e), 0, t) : e.split(r, t) : []; }
function transformTransitionDuration(e) { var r = split_1(e, ","), t = toNumber_1(trimEnd_1(toLower(r[0]), "s")); return _isNaN(t) ? 0 : 1e3 * t; }
function getTransitionDurationFromElement(e) { if (!e)
    return 0; var r = window.getComputedStyle(e, null), t = r.getPropertyValue("animation-duration"), n = r.getPropertyValue("transition-duration"), i = []; return i.push(transformTransitionDuration(t)), i.push(transformTransitionDuration(n)), max_1(i); }
export { getTransitionDurationFromElement as a, eq_1 as b, _isIndex as c, toNumber_1 as d, _baseUnary as e, _nodeUtil as f, identity_1 as g, split as h, _isNaN as i, isNumber_1 as j };
